# beaver
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

require 'date'
require 'json'
require 'faraday'
require 'certifi'
require 'logging'

require_relative 'beaver/api_helper.rb'
require_relative 'beaver/client.rb'

# Utilities
require_relative 'beaver/utilities/file_wrapper.rb'

# Http
require_relative 'beaver/http/http_call_back.rb'
require_relative 'beaver/http/http_client.rb'
require_relative 'beaver/http/faraday_client.rb'
require_relative 'beaver/http/http_method_enum.rb'
require_relative 'beaver/http/http_request.rb'
require_relative 'beaver/http/http_response.rb'
require_relative 'beaver/http/auth/custom_header_auth.rb'

# Models
require_relative 'beaver/models/base_model.rb'
require_relative 'beaver/models/partner_service.rb'
require_relative 'beaver/models/address_rbits.rb'
require_relative 'beaver/models/country_opted_out_methods.rb'
require_relative 'beaver/models/owner_of_items.rb'
require_relative 'beaver/models/terms.rb'
require_relative 'beaver/models/weight.rb'
require_relative 'beaver/models/phone_legal_entities_nullable.rb'
require_relative 'beaver/models/human_name_full_nullable.rb'
require_relative 'beaver/models/address_legal_entities_nullable.rb'
require_relative 'beaver/models/mfa_rbit.rb'
require_relative 'beaver/models/phone_rbit.rb'
require_relative 'beaver/models/person_rbit.rb'
require_relative 'beaver/models/partner_service_rbit.rb'
require_relative 'beaver/models/industry_code.rb'
require_relative 'beaver/models/fundraising_update.rb'
require_relative 'beaver/models/address_rbit.rb'
require_relative 'beaver/models/auto_billing.rb'
require_relative 'beaver/models/business_description.rb'
require_relative 'beaver/models/business_name.rb'
require_relative 'beaver/models/external_account.rb'
require_relative 'beaver/models/fundraising_event.rb'
require_relative 'beaver/models/transaction_details.rb'
require_relative 'beaver/models/address_payments_resp.rb'
require_relative 'beaver/models/pricing_by_currency.rb'
require_relative 'beaver/models/countries_opted_out_methods.rb'
require_relative 'beaver/models/item_nullable_resp.rb'
require_relative 'beaver/models/additional_representative_req.rb'
require_relative 'beaver/models/address_payments_req.rb'
require_relative 'beaver/models/address_terminals_resp.rb'
require_relative 'beaver/models/terminals_tip.rb'
require_relative 'beaver/models/quick_chip.rb'
require_relative 'beaver/models/additional_representative_resp.rb'
require_relative 'beaver/models/deferred_authorization.rb'
require_relative 'beaver/models/holder_resp.rb'
require_relative 'beaver/models/opted_out_methods.rb'
require_relative 'beaver/models/transactions_summary_summaries.rb'
require_relative 'beaver/models/recovery_pending_reason.rb'
require_relative 'beaver/models/refund_pending_reason.rb'
require_relative 'beaver/models/payment_pending_reason.rb'
require_relative 'beaver/models/payout_pending_reason.rb'
require_relative 'beaver/models/transaction_record_non_expanded.rb'
require_relative 'beaver/models/payout_failure_reason.rb'
require_relative 'beaver/models/owner_is_account.rb'
require_relative 'beaver/models/payout_method_non_expanded.rb'
require_relative 'beaver/models/payment_method_non_expanded.rb'
require_relative 'beaver/models/order_non_expanded.rb'
require_relative 'beaver/models/payment_failure_reason.rb'
require_relative 'beaver/models/holder_req.rb'
require_relative 'beaver/models/token.rb'
require_relative 'beaver/models/controller_req.rb'
require_relative 'beaver/models/additional_representatives_req.rb'
require_relative 'beaver/models/terms_nullable.rb'
require_relative 'beaver/models/address_nullable.rb'
require_relative 'beaver/models/owner_legal_entities_nullable.rb'
require_relative 'beaver/models/owner_applications.rb'
require_relative 'beaver/models/controller_resp.rb'
require_relative 'beaver/models/additional_representatives_resp.rb'
require_relative 'beaver/models/recovery_failure_reason.rb'
require_relative 'beaver/models/dispute_reason.rb'
require_relative 'beaver/models/payment_non_expanded.rb'
require_relative 'beaver/models/pricing.rb'
require_relative 'beaver/models/refund_amounts.rb'
require_relative 'beaver/models/payout_resp.rb'
require_relative 'beaver/models/refund_failure_reason.rb'
require_relative 'beaver/models/owner_legal_entities.rb'
require_relative 'beaver/models/incoming_payments_resp.rb'
require_relative 'beaver/models/item_nullable_req.rb'
require_relative 'beaver/models/refund_resp.rb'
require_relative 'beaver/models/recoveries.rb'
require_relative 'beaver/models/payout_method_resp.rb'
require_relative 'beaver/models/payout.rb'
require_relative 'beaver/models/payment_method_resp.rb'
require_relative 'beaver/models/payments_v30.rb'
require_relative 'beaver/models/payment_bank_us_req.rb'
require_relative 'beaver/models/legal_entity.rb'
require_relative 'beaver/models/order_resp.rb'
require_relative 'beaver/models/address_terminals_req.rb'
require_relative 'beaver/models/contactless_payments_req.rb'
require_relative 'beaver/models/terminal_resp.rb'
require_relative 'beaver/models/legal_entity_resp.rb'
require_relative 'beaver/models/item_resp.rb'
require_relative 'beaver/models/disputes.rb'
require_relative 'beaver/models/transactions_summary.rb'
require_relative 'beaver/models/interchange_fee.rb'
require_relative 'beaver/models/billing_statement.rb'
require_relative 'beaver/models/adjustments.rb'
require_relative 'beaver/models/account_resp.rb'
require_relative 'beaver/models/transaction_record.rb'
require_relative 'beaver/models/owner_accounts.rb'
require_relative 'beaver/models/incoming_payments_req.rb'
require_relative 'beaver/models/capture_amounts.rb'
require_relative 'beaver/models/payment_method_for_payments.rb'
require_relative 'beaver/models/payment_method_req.rb'
require_relative 'beaver/models/payout_req.rb'
require_relative 'beaver/models/payout_method_req.rb'
require_relative 'beaver/models/capabilities_resp.rb'
require_relative 'beaver/models/item_req.rb'
require_relative 'beaver/models/refund_req.rb'
require_relative 'beaver/models/order_req.rb'
require_relative 'beaver/models/accounts_capabilities_request.rb'
require_relative 'beaver/models/accounts_request.rb'
require_relative 'beaver/models/accounts_request1.rb'
require_relative 'beaver/models/accounts_response.rb'
require_relative 'beaver/models/additional_representatives.rb'
require_relative 'beaver/models/additional_representatives1.rb'
require_relative 'beaver/models/adjustments_request.rb'
require_relative 'beaver/models/adjustments_response.rb'
require_relative 'beaver/models/application_block.rb'
require_relative 'beaver/models/application_block4.rb'
require_relative 'beaver/models/associated_phone.rb'
require_relative 'beaver/models/associated_resource.rb'
require_relative 'beaver/models/balances.rb'
require_relative 'beaver/models/billing_statements_interchange_fees_response.rb'
require_relative 'beaver/models/billing_statements_response.rb'
require_relative 'beaver/models/billing_statements_transactions_summary' \
                 '_response.rb'
require_relative 'beaver/models/buyer.rb'
require_relative 'beaver/models/ca.rb'
require_relative 'beaver/models/ca1.rb'
require_relative 'beaver/models/ca4.rb'
require_relative 'beaver/models/cad.rb'
require_relative 'beaver/models/cad1.rb'
require_relative 'beaver/models/cad2.rb'
require_relative 'beaver/models/contactless_payments.rb'
require_relative 'beaver/models/controller.rb'
require_relative 'beaver/models/controller1.rb'
require_relative 'beaver/models/credit_card.rb'
require_relative 'beaver/models/credit_card1.rb'
require_relative 'beaver/models/credit_card2.rb'
require_relative 'beaver/models/credit_card4.rb'
require_relative 'beaver/models/currencies.rb'
require_relative 'beaver/models/currencies1.rb'
require_relative 'beaver/models/currencies2.rb'
require_relative 'beaver/models/currencies3.rb'
require_relative 'beaver/models/current_issue.rb'
require_relative 'beaver/models/current_issue2.rb'
require_relative 'beaver/models/date_of_birth.rb'
require_relative 'beaver/models/detail.rb'
require_relative 'beaver/models/detail1.rb'
require_relative 'beaver/models/detail2.rb'
require_relative 'beaver/models/detail3.rb'
require_relative 'beaver/models/detail4.rb'
require_relative 'beaver/models/detail5.rb'
require_relative 'beaver/models/detail6.rb'
require_relative 'beaver/models/detail7.rb'
require_relative 'beaver/models/detail8.rb'
require_relative 'beaver/models/detail9.rb'
require_relative 'beaver/models/detail10.rb'
require_relative 'beaver/models/disputes_request.rb'
require_relative 'beaver/models/disputes_response.rb'
require_relative 'beaver/models/document.rb'
require_relative 'beaver/models/documentation.rb'
require_relative 'beaver/models/documentation1.rb'
require_relative 'beaver/models/embedded_rbit.rb'
require_relative 'beaver/models/entity_country_info.rb'
require_relative 'beaver/models/entity_verification.rb'
require_relative 'beaver/models/entity_verification1.rb'
require_relative 'beaver/models/flat_guide.rb'
require_relative 'beaver/models/gb.rb'
require_relative 'beaver/models/gbp.rb'
require_relative 'beaver/models/gbp1.rb'
require_relative 'beaver/models/gbp2.rb'
require_relative 'beaver/models/industry.rb'
require_relative 'beaver/models/interchange_plus.rb'
require_relative 'beaver/models/itemized_receipt.rb'
require_relative 'beaver/models/items_response.rb'
require_relative 'beaver/models/legal_entities_request.rb'
require_relative 'beaver/models/legal_entities_response.rb'
require_relative 'beaver/models/legal_entities_verifications_request.rb'
require_relative 'beaver/models/legal_entities_verifications_response.rb'
require_relative 'beaver/models/line_item.rb'
require_relative 'beaver/models/line_item1.rb'
require_relative 'beaver/models/name.rb'
require_relative 'beaver/models/notification_preferences_request.rb'
require_relative 'beaver/models/notification_preferences_request1.rb'
require_relative 'beaver/models/notification_preferences_response.rb'
require_relative 'beaver/models/notification_preferences_response1.rb'
require_relative 'beaver/models/notification_preferences_response2.rb'
require_relative 'beaver/models/notifications_response.rb'
require_relative 'beaver/models/notifications_response1.rb'
require_relative 'beaver/models/orders_response.rb'
require_relative 'beaver/models/owner3.rb'
require_relative 'beaver/models/owner16.rb'
require_relative 'beaver/models/owner20.rb'
require_relative 'beaver/models/payment_methods_request.rb'
require_relative 'beaver/models/payment_methods_response.rb'
require_relative 'beaver/models/payment_methods_verify_bank_deposits_request.rb'
require_relative 'beaver/models/payment_bank.rb'
require_relative 'beaver/models/payment_bank_us.rb'
require_relative 'beaver/models/payments.rb'
require_relative 'beaver/models/payments_cancel_request.rb'
require_relative 'beaver/models/payments_capture_request.rb'
require_relative 'beaver/models/payments_request.rb'
require_relative 'beaver/models/payments_request1.rb'
require_relative 'beaver/models/payments_response.rb'
require_relative 'beaver/models/payments1.rb'
require_relative 'beaver/models/payout_methods_request.rb'
require_relative 'beaver/models/payout_methods_response.rb'
require_relative 'beaver/models/payout_bank_ca.rb'
require_relative 'beaver/models/payout_bank_ca1.rb'
require_relative 'beaver/models/payout_bank_gb.rb'
require_relative 'beaver/models/payout_bank_gb1.rb'
require_relative 'beaver/models/payout_bank_us.rb'
require_relative 'beaver/models/payout_bank_us1.rb'
require_relative 'beaver/models/payouts.rb'
require_relative 'beaver/models/payouts_request.rb'
require_relative 'beaver/models/payouts_response.rb'
require_relative 'beaver/models/payouts1.rb'
require_relative 'beaver/models/percentage_guide.rb'
require_relative 'beaver/models/personal_country_info.rb'
require_relative 'beaver/models/personal_country_info1.rb'
require_relative 'beaver/models/personal_verification.rb'
require_relative 'beaver/models/personal_verification5.rb'
require_relative 'beaver/models/phone.rb'
require_relative 'beaver/models/phone1.rb'
require_relative 'beaver/models/rbits_request.rb'
require_relative 'beaver/models/rbits_response.rb'
require_relative 'beaver/models/rbits_response1.rb'
require_relative 'beaver/models/reason.rb'
require_relative 'beaver/models/recoveries_request.rb'
require_relative 'beaver/models/recoveries_response.rb'
require_relative 'beaver/models/refunds_request.rb'
require_relative 'beaver/models/refunds_response.rb'
require_relative 'beaver/models/reject_reason.rb'
require_relative 'beaver/models/representative0.rb'
require_relative 'beaver/models/representative01.rb'
require_relative 'beaver/models/resolution.rb'
require_relative 'beaver/models/result.rb'
require_relative 'beaver/models/result1.rb'
require_relative 'beaver/models/result2.rb'
require_relative 'beaver/models/shipping_info.rb'
require_relative 'beaver/models/shipping_status.rb'
require_relative 'beaver/models/shipping_status1.rb'
require_relative 'beaver/models/standard.rb'
require_relative 'beaver/models/target.rb'
require_relative 'beaver/models/terminal_configuration.rb'
require_relative 'beaver/models/terminal_configuration1.rb'
require_relative 'beaver/models/terminal_configuration2.rb'
require_relative 'beaver/models/terminal_display.rb'
require_relative 'beaver/models/terminals_request.rb'
require_relative 'beaver/models/terminals_request1.rb'
require_relative 'beaver/models/terminals_response.rb'
require_relative 'beaver/models/terms_of_service.rb'
require_relative 'beaver/models/tokens_request.rb'
require_relative 'beaver/models/tokens_response.rb'
require_relative 'beaver/models/transaction_records_response.rb'
require_relative 'beaver/models/upcoming_issue.rb'
require_relative 'beaver/models/us.rb'
require_relative 'beaver/models/us1.rb'
require_relative 'beaver/models/us4.rb'
require_relative 'beaver/models/usd.rb'
require_relative 'beaver/models/usd1.rb'
require_relative 'beaver/models/usd2.rb'
require_relative 'beaver/models/currency_enum.rb'
require_relative 'beaver/models/country_code_enum.rb'
require_relative 'beaver/models/rbit_types_enum.rb'
require_relative 'beaver/models/rbit_source_enum.rb'
require_relative 'beaver/models/fee_type_enum.rb'
require_relative 'beaver/models/resource_legal_entities_enum.rb'
require_relative 'beaver/models/resource_types_rbit_enum.rb'
require_relative 'beaver/models/initiated_by_resp_enum.rb'
require_relative 'beaver/models/resource_payments_enum.rb'
require_relative 'beaver/models/currency_nullable_enum.rb'
require_relative 'beaver/models/resource_notifications_enum.rb'
require_relative 'beaver/models/terminals_status_enum.rb'
require_relative 'beaver/models/resource_accounts_enum.rb'
require_relative 'beaver/models/resource_verifications_enum.rb'
require_relative 'beaver/models/resource_capabilities_enum.rb'
require_relative 'beaver/models/initiated_by_req_enum.rb'
require_relative 'beaver/models/account_type_enum.rb'
require_relative 'beaver/models/address_type_enum.rb'
require_relative 'beaver/models/amount_guide_type_enum.rb'
require_relative 'beaver/models/card_brand2_enum.rb'
require_relative 'beaver/models/card_brand_enum.rb'
require_relative 'beaver/models/card_entry_type_enum.rb'
require_relative 'beaver/models/code_type_enum.rb'
require_relative 'beaver/models/credit_debit_preference_enum.rb'
require_relative 'beaver/models/credit_debit_preference1_enum.rb'
require_relative 'beaver/models/delivery_type_enum.rb'
require_relative 'beaver/models/detail_code_enum.rb'
require_relative 'beaver/models/detail_code1_enum.rb'
require_relative 'beaver/models/detail_code2_enum.rb'
require_relative 'beaver/models/detail_code3_enum.rb'
require_relative 'beaver/models/detail_code4_enum.rb'
require_relative 'beaver/models/detail_code5_enum.rb'
require_relative 'beaver/models/detail_code6_enum.rb'
require_relative 'beaver/models/detail_code7_enum.rb'
require_relative 'beaver/models/detail_code8_enum.rb'
require_relative 'beaver/models/detail_code9_enum.rb'
require_relative 'beaver/models/detail_code10_enum.rb'
require_relative 'beaver/models/errant_field_enum.rb'
require_relative 'beaver/models/issue_type_enum.rb'
require_relative 'beaver/models/issue_type4_enum.rb'
require_relative 'beaver/models/legal_form_enum.rb'
require_relative 'beaver/models/legal_form1_enum.rb'
require_relative 'beaver/models/mfa_action_enum.rb'
require_relative 'beaver/models/mode_enum.rb'
require_relative 'beaver/models/model_enum.rb'
require_relative 'beaver/models/model1_enum.rb'
require_relative 'beaver/models/name_type_enum.rb'
require_relative 'beaver/models/payment_method_type_enum.rb'
require_relative 'beaver/models/payout_method_type_enum.rb'
require_relative 'beaver/models/period_enum.rb'
require_relative 'beaver/models/phone_type_enum.rb'
require_relative 'beaver/models/reason_code_enum.rb'
require_relative 'beaver/models/reason_code1_enum.rb'
require_relative 'beaver/models/reason_code2_enum.rb'
require_relative 'beaver/models/reason_code3_enum.rb'
require_relative 'beaver/models/reason_code4_enum.rb'
require_relative 'beaver/models/reason_code5_enum.rb'
require_relative 'beaver/models/reason_code6_enum.rb'
require_relative 'beaver/models/reason_code7_enum.rb'
require_relative 'beaver/models/reason_code8_enum.rb'
require_relative 'beaver/models/reason_code9_enum.rb'
require_relative 'beaver/models/resource_enum.rb'
require_relative 'beaver/models/resource1_enum.rb'
require_relative 'beaver/models/resource2_enum.rb'
require_relative 'beaver/models/role_enum.rb'
require_relative 'beaver/models/service_billing_method_enum.rb'
require_relative 'beaver/models/setup_by_enum.rb'
require_relative 'beaver/models/state_enum.rb'
require_relative 'beaver/models/status_enum.rb'
require_relative 'beaver/models/status2_enum.rb'
require_relative 'beaver/models/status3_enum.rb'
require_relative 'beaver/models/status4_enum.rb'
require_relative 'beaver/models/status5_enum.rb'
require_relative 'beaver/models/status8_enum.rb'
require_relative 'beaver/models/status20_enum.rb'
require_relative 'beaver/models/supported_card_entry_mode_enum.rb'
require_relative 'beaver/models/terminals_supported_card_brand_enum.rb'
require_relative 'beaver/models/timezone_enum.rb'
require_relative 'beaver/models/topic_enum.rb'
require_relative 'beaver/models/topic1_enum.rb'
require_relative 'beaver/models/type_enum.rb'
require_relative 'beaver/models/type2_enum.rb'
require_relative 'beaver/models/type3_enum.rb'
require_relative 'beaver/models/type4_enum.rb'
require_relative 'beaver/models/type5_enum.rb'
require_relative 'beaver/models/type6_enum.rb'
require_relative 'beaver/models/type7_enum.rb'
require_relative 'beaver/models/type8_enum.rb'
require_relative 'beaver/models/type9_enum.rb'
require_relative 'beaver/models/type12_enum.rb'
require_relative 'beaver/models/type15_enum.rb'
require_relative 'beaver/models/type27_enum.rb'
require_relative 'beaver/models/units_enum.rb'
require_relative 'beaver/models/virtual_terminal_mode_enum.rb'

# Exceptions
require_relative 'beaver/exceptions/api_exception.rb'

require_relative 'beaver/configuration.rb'

# Controllers
require_relative 'beaver/controllers/base_controller.rb'
require_relative 'beaver/controllers/api_controller.rb'
