# beaver
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module Beaver
  # An enum for SDK environments.
  class Environment
    # PRODUCTION: POC
    # ENVIRONMENT2: Internal Stage
    # ENVIRONMENT3: External Stage
    # ENVIRONMENT4: Production
    ENVIRONMENT = [
      PRODUCTION = 'production'.freeze,
      ENVIRONMENT2 = 'environment2'.freeze,
      ENVIRONMENT3 = 'environment3'.freeze,
      ENVIRONMENT4 = 'environment4'.freeze
    ].freeze
  end

  # An enum for API servers.
  class Server
    SERVER = [
      DEFAULT = 'default'.freeze
    ].freeze
  end

  # All configuration including auth info and base URI for the API access
  # are configured in this class.
  class Configuration
    # The attribute readers for properties.
    attr_reader :http_client
    attr_reader :timeout
    attr_reader :max_retries
    attr_reader :retry_interval
    attr_reader :backoff_factor
    attr_reader :environment
    attr_reader :app_token

    class << self
      attr_reader :environments
    end

    def initialize(timeout: 60, max_retries: 0, retry_interval: 1,
                   backoff_factor: 1, environment: Environment::PRODUCTION,
                   app_token: '')
      # The value to use for connection timeout
      @timeout = timeout

      # The number of times to retry an endpoint call if it fails
      @max_retries = max_retries

      # Pause in seconds between retries
      @retry_interval = retry_interval

      # The amount to multiply each successive retry's interval amount
      # by in order to provide backoff
      @backoff_factor = backoff_factor

      # Current API environment
      @environment = String(environment)

      # TODO: Replace
      @app_token = app_token

      # The Http Client to use for making requests.
      @http_client = create_http_client
    end

    def clone_with(timeout: nil, max_retries: nil, retry_interval: nil,
                   backoff_factor: nil, environment: nil, app_token: nil)
      timeout ||= self.timeout
      max_retries ||= self.max_retries
      retry_interval ||= self.retry_interval
      backoff_factor ||= self.backoff_factor
      environment ||= self.environment
      app_token ||= self.app_token

      Configuration.new(timeout: timeout, max_retries: max_retries,
                        retry_interval: retry_interval,
                        backoff_factor: backoff_factor,
                        environment: environment, app_token: app_token)
    end

    def create_http_client
      FaradayClient.new(timeout: timeout, max_retries: max_retries,
                        retry_interval: retry_interval,
                        backoff_factor: backoff_factor)
    end

    # All the environments the SDK can run in.
    ENVIRONMENTS = {
      Environment::PRODUCTION => {
        Server::DEFAULT => 'http://poc-services.devops.wepay-inc.com/https/api/beaver'
      },
      Environment::ENVIRONMENT2 => {
        Server::DEFAULT => 'https://tst-api-v3.wepay-inc.com'
      },
      Environment::ENVIRONMENT3 => {
        Server::DEFAULT => 'https://stage-api.wepay.com'
      },
      Environment::ENVIRONMENT4 => {
        Server::DEFAULT => 'https://api.wepay.com'
      }
    }.freeze

    # Generates the appropriate base URI for the environment and the server.
    # @param [Configuration::Server] The server enum for which the base URI is
    # required.
    # @return [String] The base URI.
    def get_base_uri(server = Server::DEFAULT)
      ENVIRONMENTS[environment][server].clone
    end
  end
end
