# beaver
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module Beaver
  # Configuration settings for deferred authorization functionality.
  class DeferredAuthorization < BaseModel
    # Determines if deferred authorization functionality is enabled.
    # @return [Boolean]
    attr_accessor :enabled

    # Determines if international payment methods are allowed for deferred
    # authorizations.
    # @return [Boolean]
    attr_accessor :international_enabled

    # The maximum number of transactions that can be processed as deferred
    # authorizations. Once exceeded, the terminal will no longer process
    # transactions until connectivity has been restored.
    # @return [Integer]
    attr_accessor :max_transaction_count

    # The maximum total amount of transaction volume that can be processed as
    # deferred authorizations. Once exceeded, the terminal will no longer
    # process transactions until connectivity has been restored.
    # @return [Integer]
    attr_accessor :max_total_amount

    # The maximum total amount of transaction volume that can be processed as
    # deferred authorizations. Once exceeded, the terminal will no longer
    # process transactions until connectivity has been restored.
    # @return [Integer]
    attr_accessor :max_transaction_amount

    # The card entry modes that are allowed in deferred authorizations.
    # @return [List of SupportedCardEntryModeEnum]
    attr_accessor :supported_card_entry_modes

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['enabled'] = 'enabled'
      @_hash['international_enabled'] = 'international_enabled'
      @_hash['max_transaction_count'] = 'max_transaction_count'
      @_hash['max_total_amount'] = 'max_total_amount'
      @_hash['max_transaction_amount'] = 'max_transaction_amount'
      @_hash['supported_card_entry_modes'] = 'supported_card_entry_modes'
      @_hash
    end

    def initialize(enabled = nil,
                   international_enabled = nil,
                   max_transaction_count = nil,
                   max_total_amount = nil,
                   max_transaction_amount = nil,
                   supported_card_entry_modes = nil)
      @enabled = enabled
      @international_enabled = international_enabled
      @max_transaction_count = max_transaction_count
      @max_total_amount = max_total_amount
      @max_transaction_amount = max_transaction_amount
      @supported_card_entry_modes = supported_card_entry_modes
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      enabled = hash['enabled']
      international_enabled = hash['international_enabled']
      max_transaction_count = hash['max_transaction_count']
      max_total_amount = hash['max_total_amount']
      max_transaction_amount = hash['max_transaction_amount']
      supported_card_entry_modes = hash['supported_card_entry_modes']

      # Create object from extracted values.
      DeferredAuthorization.new(enabled,
                                international_enabled,
                                max_transaction_count,
                                max_total_amount,
                                max_transaction_amount,
                                supported_card_entry_modes)
    end
  end
end
