# beaver
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module Beaver
  # The standard pricing model for payment banks to collect platform fees.
  class Standard < BaseModel
    # The fixed fee amount.
    # @return [Integer]
    attr_accessor :fixed_fee_amount

    # The basis points to calculate variable fee amount.
    # @return [Integer]
    attr_accessor :variable_fee_bps

    # The max value of total fee amount.
    # @return [Integer]
    attr_accessor :max_fee_amount

    # The min value of total fee amount.
    # @return [Integer]
    attr_accessor :min_fee_amount

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['fixed_fee_amount'] = 'fixed_fee_amount'
      @_hash['variable_fee_bps'] = 'variable_fee_bps'
      @_hash['max_fee_amount'] = 'max_fee_amount'
      @_hash['min_fee_amount'] = 'min_fee_amount'
      @_hash
    end

    def initialize(fixed_fee_amount = nil,
                   variable_fee_bps = nil,
                   max_fee_amount = nil,
                   min_fee_amount = nil)
      @fixed_fee_amount = fixed_fee_amount
      @variable_fee_bps = variable_fee_bps
      @max_fee_amount = max_fee_amount
      @min_fee_amount = min_fee_amount
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      fixed_fee_amount = hash['fixed_fee_amount']
      variable_fee_bps = hash['variable_fee_bps']
      max_fee_amount = hash['max_fee_amount']
      min_fee_amount = hash['min_fee_amount']

      # Create object from extracted values.
      Standard.new(fixed_fee_amount,
                   variable_fee_bps,
                   max_fee_amount,
                   min_fee_amount)
    end
  end
end
