# beaver
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module Beaver
  # TerminalConfiguration Model.
  class TerminalConfiguration < BaseModel
    # TODO: Write general description for this method
    # @return [AddressTerminalsResp]
    attr_accessor :address

    # TODO: Write general description for this method
    # @return [CurrencyEnum]
    attr_accessor :currency

    # The collection of card brands that are supported by the terminal. Must
    # provide at least one.
    # @return [List of TerminalsSupportedCardBrandEnum]
    attr_accessor :supported_card_brands

    # Determines how the terminal should prefer credit vs debit when a card is
    # dipped. "credit" indicates credit is the preferred application selection,
    # whereas "debit" would prefer the debit application. "prompt" will perform
    # the EMV default behavior, which is to prompt if multiple applications
    # exist.
    # @return [CreditDebitPreference1Enum]
    attr_accessor :credit_debit_preference

    # The identifier of the SIM card installed in the terminal. Nullable if
    # terminal does not have a SIM card.
    # @return [String]
    attr_accessor :sim_card_id

    # Timezone of the terminal'
    # @return [TimezoneEnum]
    attr_accessor :timezone

    # Timezone of the terminal'
    # @return [TerminalsTip]
    attr_accessor :tip

    # Whether or not this terminal requires signature verification from payers.
    # @return [Boolean]
    attr_accessor :signature_required

    # The response schema for contactless payments configuration.
    # @return [ContactlessPayments]
    attr_accessor :contactless_payments

    # Configuration settings for quick chip functionality.
    # @return [QuickChip]
    attr_accessor :quick_chip

    # Configuration settings for deferred authorization functionality.
    # @return [DeferredAuthorization]
    attr_accessor :deferred_authorization

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['address'] = 'address'
      @_hash['currency'] = 'currency'
      @_hash['supported_card_brands'] = 'supported_card_brands'
      @_hash['credit_debit_preference'] = 'credit_debit_preference'
      @_hash['sim_card_id'] = 'sim_card_id'
      @_hash['timezone'] = 'timezone'
      @_hash['tip'] = 'tip'
      @_hash['signature_required'] = 'signature_required'
      @_hash['contactless_payments'] = 'contactless_payments'
      @_hash['quick_chip'] = 'quick_chip'
      @_hash['deferred_authorization'] = 'deferred_authorization'
      @_hash
    end

    def initialize(address = nil,
                   currency = nil,
                   supported_card_brands = nil,
                   credit_debit_preference = nil,
                   timezone = nil,
                   tip = nil,
                   signature_required = nil,
                   contactless_payments = nil,
                   quick_chip = nil,
                   deferred_authorization = nil,
                   sim_card_id = nil)
      @address = address
      @currency = currency
      @supported_card_brands = supported_card_brands
      @credit_debit_preference = credit_debit_preference
      @sim_card_id = sim_card_id
      @timezone = timezone
      @tip = tip
      @signature_required = signature_required
      @contactless_payments = contactless_payments
      @quick_chip = quick_chip
      @deferred_authorization = deferred_authorization
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      address = AddressTerminalsResp.from_hash(hash['address']) if
        hash['address']
      currency = hash['currency']
      supported_card_brands = hash['supported_card_brands']
      credit_debit_preference = hash['credit_debit_preference']
      timezone = hash['timezone']
      tip = TerminalsTip.from_hash(hash['tip']) if hash['tip']
      signature_required = hash['signature_required']
      if hash['contactless_payments']
        contactless_payments = ContactlessPayments.from_hash(hash['contactless_payments'])
      end
      quick_chip = QuickChip.from_hash(hash['quick_chip']) if
        hash['quick_chip']
      if hash['deferred_authorization']
        deferred_authorization = DeferredAuthorization.from_hash(hash['deferred_authorization'])
      end
      sim_card_id = hash['sim_card_id']

      # Create object from extracted values.
      TerminalConfiguration.new(address,
                                currency,
                                supported_card_brands,
                                credit_debit_preference,
                                timezone,
                                tip,
                                signature_required,
                                contactless_payments,
                                quick_chip,
                                deferred_authorization,
                                sim_card_id)
    end
  end
end
