# beaver
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module Beaver
  # This configuration is required if the mode is "prompt_on_terminal", and is
  # responsible for configuring how the tip guide appears on the physical
  # terminal.
  class TerminalDisplay < BaseModel
    # The type of the amount guide can be either a percentage guide or a flat
    # guide. Percentage guides will offer the payer a chance to tip with one of
    # a few default tip percentages that are configured. Flat guides will offer
    # the payer flat tip amounts to choose from. Both types of guides will allow
    # the payer to manually enter a tip amount.
    # @return [AmountGuideTypeEnum]
    attr_accessor :amount_guide_type

    # The configuration for a percentage tip guide. All three guides must be
    # provided.
    # @return [PercentageGuide]
    attr_accessor :percentage_guide

    # The configuration for a flat tip guide. All three guides must be provided.
    # @return [FlatGuide]
    attr_accessor :flat_guide

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['amount_guide_type'] = 'amount_guide_type'
      @_hash['percentage_guide'] = 'percentage_guide'
      @_hash['flat_guide'] = 'flat_guide'
      @_hash
    end

    def initialize(amount_guide_type = nil,
                   percentage_guide = nil,
                   flat_guide = nil)
      @amount_guide_type = amount_guide_type
      @percentage_guide = percentage_guide
      @flat_guide = flat_guide
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      amount_guide_type = hash['amount_guide_type']
      percentage_guide = PercentageGuide.from_hash(hash['percentage_guide']) if
        hash['percentage_guide']
      flat_guide = FlatGuide.from_hash(hash['flat_guide']) if
        hash['flat_guide']

      # Create object from extracted values.
      TerminalDisplay.new(amount_guide_type,
                          percentage_guide,
                          flat_guide)
    end
  end
end
