# beaver
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module Beaver
  # TerminalsTip Model.
  class TerminalsTip < BaseModel
    # The way in which tip is handled by this terminal. If "disabled", tip will
    # not be prompted for. Otherwise, value determines if the prompt should
    # appear on the terminal or on the receipt. Note: If set to
    # "prompt_on_terminal" then you must provide the "terminal_display" field as
    # well.
    # @return [ModeEnum]
    attr_accessor :mode

    # This configuration is required if the mode is "prompt_on_terminal", and is
    # responsible for configuring how the tip guide appears on the physical
    # terminal.
    # @return [TerminalDisplay]
    attr_accessor :terminal_display

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['mode'] = 'mode'
      @_hash['terminal_display'] = 'terminal_display'
      @_hash
    end

    def initialize(mode = nil,
                   terminal_display = nil)
      @mode = mode
      @terminal_display = terminal_display
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      mode = hash['mode']
      terminal_display = TerminalDisplay.from_hash(hash['terminal_display']) if
        hash['terminal_display']

      # Create object from extracted values.
      TerminalsTip.new(mode,
                       terminal_display)
    end
  end
end
